package cloud;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Panel;
import java.io.InputStream;
import java.lang.*;
import java.net.URL;
import cloud.atom.AtomInfo;
import cloud.io.AtomReader;

//--------------------------------------------------------------------//
/**
 * dq_ CNX
 * @author aG
 * @version 1.1
 */
public class CloudApplet extends Applet{

/** G[bZ[W */
  protected String message;

//--------------------------------------------------------------------//
/**
 * Avbg
 */
  public void init(){
    AtomInfo info[]=getAtomInfo();
    setLayout(new BorderLayout());
    if(info==null){
      add(new CloudViewCanvas(null,message),BorderLayout.CENTER);
    }
    else{
      CloudViewCanvas canvas=new CloudViewCanvas(info[0],message);
      Panel cont=new Panel(new FlowLayout());
      cont.add(new AtomChoice(canvas,info));
      add(canvas,BorderLayout.CENTER);
      add(cont,BorderLayout.SOUTH);
    }
  }

//--------------------------------------------------------------------//
/**
 * q擾
 * @return qi[z
 */
  protected AtomInfo[] getAtomInfo(){
    String dataName=getParameter("datafile");
    if(dataName==null) dataName="atom.txt";
    message=null;
    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
    }
    catch(SecurityException ex){
      message=ex.toString();
      return null;
    }
    try{
      return AtomReader.read(new URL(getDocumentBase(),dataName));
    }
    catch(Exception ex){
      message=ex.toString();
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * \[Xj
 */
  public void destroy(){
    removeAll();
  }

//--------------------------------------------------------------------//
/**
 * AvbgԂ
 * @return Avbg܂ޕ
 */
  public String getAppletInfo(){
    return "Applet of electron cloud\n"
      	  +"Author K.Higuchi";
  }

//--------------------------------------------------------------------//
/**
 * ̃Avbg߂p[^Ԃ
 * @return Avbg߂p[^i[z
 */
  public String[][] getParameterInfo(){
    String info[][]=
      {{"datafile","String","Atom data file name."}};
    return info;
  }
}
