package cloud.atom;
import java.lang.*;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * q̓dqOvZ̒ۃX[p[NX
 */
public abstract class AbstractAtom implements Atom{

/** qԍ */
  protected int z;

/** f[^̐ */
  protected int nn;

/** dqOi[Xg */
  protected OrbitList orbitList;

/** ai[z */
  protected double r[];

/** <i>x</i> ̍ݕ */
  protected double dx;

/** qj̃N[|eVi[z */
  protected double u[];

/** 臒l */
  protected double tol;

/** ɘaW */
  protected double eps;

/**
 * q̓dqOvZIuWFNg\z
 * @param orbitList dqOi[Xg
 * @param z qԍ
 * @param nn f[^̐
 * @param r ai[z
 * @param dx <i>x</i> ̍ݕ
 */
  protected AbstractAtom(OrbitList orbitList,int z,int nn,double r[],
      	      	      	 double dx){
    this.orbitList=orbitList;
    this.z=z;
    this.nn=nn;
    this.r=r;
    this.dx=dx;
    u=new double[nn+1];
    Arrays.fill(u,-(double)z);
    tol=1.0E-6;
    eps=0.3;
  }

//--------------------------------------------------------------------//
/**
 * N[GlM[vZ
 * @param index f[^̃CfbNX
 * @return w肳ꂽʒũN[GlM[
 */
  protected abstract double coulomb(int index);

/**
 * ֍vZ
 * @param index f[^̃CfbNX
 * @return w肳ꂽʒǔ֍
 */
  protected abstract double exchange(int index);

//--------------------------------------------------------------------//
/**
 * dqǑvZ
 */
  public void calculate(){
    orbitList.calcWaveFuction(r,u,dx);
    double pre=0.0;
    double total=totalEnergy();
    do{
      update();
      orbitList.calcWaveFuction(r,u,dx);
      pre=total;
      total=totalEnergy();
    }while(Math.abs(total-pre)>tol);
//    System.out.println("Total energy = "+total);
  }

//--------------------------------------------------------------------//
/**
 * |eVXV
 */
  protected void update(){
    double du[]=new double[nn+1];
    for(int i=0;i<=nn;i++){
      du[i]=eps*(-(double)z+coulomb(i)+exchange(i)-u[i]);
      u[i]+=du[i];
    }
    orbitList.updateEnergy(du,dx);
  }

//--------------------------------------------------------------------//
/**
 * SGlM[vZ
 * @return Sdq̃GlM[
 */
  public double totalEnergy(){
    double dee=0.0;
    for(int i=0;i<=nn;i++){
      dee+=(2.0*coulomb(i)+exchange(i))*orbitList.density(i);
    }
    return orbitList.energy()-0.25*dee*dx;
  }

//--------------------------------------------------------------------//
/**
 * dqxԂ
 * @param index dqx̃CfbNX
 * @return w肳ꂽʒȗSO̓dqx
 */
  public double density(int index){
    return orbitList.density(index);
  }

//--------------------------------------------------------------------//
/**
 * GlM[Ԃ
 * @return SÕGlM[
 */
  public double energy(){
    return orbitList.energy();
  }
}
