package cloud.atom;
import java.lang.*;
import cloud.DistributionFunction;

//--------------------------------------------------------------------//
/**
 * q̓dqOvZNX
 */
public class AtomImpl extends AbstractAtom{

/** 1/3 */
  public static final double D1_3=1.0/3.0;

/** ֍̌W */
  public static final double
    EXCHANGE=2.0*Math.pow(3.0/(32.0*Math.PI*Math.PI),D1_3);

/** ʊp̌vZ̕ */
  public static final int ANGLE_COUNT=36;

/**
 * q̓dqOvZIuWFNg\z
 * @param orbitList dqOi[Xg
 * @param z qԍ
 * @param nn f[^̐
 * @param r ai[z
 * @param dx <i>x</i> ̍ݕ
 */
  public AtomImpl(OrbitList orbitList,int z,int nn,double r[],double dx){
    super(orbitList,z,nn,r,dx);
  }

//--------------------------------------------------------------------//
/**
 * N[GlM[vZ
 * @param index f[^̃CfbNX
 * @return w肳ꂽʒũN[GlM[
 */
  protected double coulomb(int index){
    if(z==1) return 0.0;
    double uc=0.0;
    for(int j=index;j<=nn;j++){
      uc+=orbitList.density(j);
    }
    uc*=r[index];
    for(int j=0;j<index;j++){
      uc+=r[j]*orbitList.density(j);
    }
    return uc*dx;
  }

//--------------------------------------------------------------------//
/**
 * ֍vZ
 * @param index f[^̃CfbNX
 * @return w肳ꂽʒǔ֍
 */
  protected double exchange(int index){
    if(z==1) return 0.0;
    double density=orbitList.density(index);
    double rs=Math.pow(6.0*r[index]*r[index]/density,D1_3);
    double beta=1.0+0.0368*rs*Math.log(1.0+21.0/rs);
    return -EXCHANGE*beta*Math.pow(density*r[index],D1_3);
  }

//--------------------------------------------------------------------//
/**
 * z֐Ԃ
 * @return z֐
 */
  public DistributionFunction getDistributionFunction(){
    return orbitList.getDistributionFunction(r,ANGLE_COUNT);
  }

//--------------------------------------------------------------------//
/**
 * z֐Ԃ
 * @return z֐
 */
  public DistributionFunction getDistributionFunctionX(){
    double x[]=new double[nn+1];
    double sqrtz=Math.sqrt((double)z);
    for(int i=0;i<=nn;i++){
      x[i]=Math.log(sqrtz*r[i]);
    }
    return orbitList.getDistributionFunctionX(x,ANGLE_COUNT);
  }
}
