package cloud.atom;
import java.lang.*;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * qNX
 */
public class AtomInfo{

/** qԍ */
  public int z;

/** q */
  public String name;

/** dqԂi[z */
  public ElectricState states[];

/**
 * q\z
 * @param z qԍ
 * @param name q
 * @param states dqԂi[z
 */
  public AtomInfo(int z,String name,ElectricState states[]){
    this.z=z;
    this.name=name;
    this.states=states;
  }

//--------------------------------------------------------------------//
/**
 * qf[^\z
 * @param nn f[^̐
 * @param xmin <i>x</i> ̍ŏl
 * @param dx <i>x</i> ̍ݕ
 * @return <code>Atom</code> CX^X
 */
  public Atom createAtom(int nn,double xmin,double dx){
    double r[]=new double[nn+1];
    double zinv=1.0/Math.sqrt((double)z);
    for(int i=0;i<=nn;i++){
      r[i]=zinv*Math.exp(dx*(double)i+xmin);
    }
    Orbit orbit[]=new Orbit[states.length];
    for(int i=0;i<states.length;i++){
      orbit[i]=new Orbit(z,nn,states[i]);
    }
    return new AtomImpl(new OrbitList(states.length,orbit),z,nn,r,dx);
  }

//--------------------------------------------------------------------//
/**
 * qԂ
 * @return q
 */
  public String getName(){
    return name;
  }

//--------------------------------------------------------------------//
/**
 * `悷ő唼aԂ
 * @return `悷ő唼a
 */
  public double getRmax(){
    return 4.0*Math.pow((double)z,-0.25);
  }

//--------------------------------------------------------------------//
/**
 * `悷镪z֐̌WԂ
 * @return z֐̌W
 */
  public double getViewCoef(){
    return 0.1*Math.pow((double)z,-0.125);
  }

//--------------------------------------------------------------------//
/**
 * <i>x</i> W𔼌a֕ϊ
 * @param x <i>x</i> W
 * @return a
 */
  public double xToR(double x){
    return Math.exp(x)/Math.sqrt((double)z);
  }

//--------------------------------------------------------------------//
/**
 * a<i>x</i> W֕ϊ
 * @param r a
 * @return <i>x</i> W
 */
  public double rToX(double r){
    if(r<=1.0E-10) return -100.0;
    else           return Math.log(Math.sqrt((double)z)*r);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuffer sb=new StringBuffer();
    sb.append(z);
    sb.append('\t');
    sb.append(name);
    for(int i=0;i<states.length;i++){
      sb.append('\t');
      sb.append(states[i]);
    }
    return sb.toString();
  }
}
