package cloud.atom;
import java.lang.*;
import cloud.DistributionFunction;
import cloud.distribution.MultiDistributionFunction;

//--------------------------------------------------------------------//
/**
 * dqÕXg
 */
public class OrbitList{

/** dqO̐ */
  protected int count;

/** dqOi[z */
  protected Orbit orbit[];

/**
 * dqÕXg\z
 * @param count dqO̐
 * @param orbit dqOi[z
 */
  public OrbitList(int count,Orbit orbit[]){
    this.count=count;
    this.orbit=orbit;
  }

//--------------------------------------------------------------------//
/**
 * Xg̓dqO̐Ԃ
 * @return Xg̓dqO̐
 */
  public int size(){
    return count;
  }

//--------------------------------------------------------------------//
/**
 * dqOԂ
 * @param index dqÕCfbNX
 * @return w肳ꂽdqO
 */
  public Orbit get(int index){
    return orbit[index];
  }

//--------------------------------------------------------------------//
/**
 * g֐vZ
 * @param r ai[z
 * @param u qj̃N[|eVi[z
 * @param dx <i>x</i> ̍ݕ
 */
  public void calcWaveFuction(double r[],double u[],double dx){
    for(int i=0;i<count;i++){
      orbit[i].calcWaveFuction(r,u,dx);
    }
  }

//--------------------------------------------------------------------//
/**
 * dqxԂ
 * @param index dqx̃CfbNX
 * @return w肳ꂽʒȗSO̓dqx
 */
  public double density(int index){
    double density=0.0;
    for(int i=0;i<count;i++){
      density+=orbit[i].density(index);
    }
    return density;
  }

//--------------------------------------------------------------------//
/**
 * GlM[Ԃ
 * @return SÕGlM[
 */
  public double energy(){
    double ee=0.0;
    for(int i=0;i<count;i++){
      ee+=orbit[i].energy();
    }
    return ee;
  }

//--------------------------------------------------------------------//
/**
 * GlM[XV
 * @param du qj̃N[|eV̕ωʂi[z
 * @param dx <i>x</i> ̍ݕ
 */
  public void updateEnergy(double du[],double dx){
    for(int i=0;i<count;i++){
      orbit[i].updateEnergy(du,dx);
    }
  }

//--------------------------------------------------------------------//
/**
 * z֐Ԃ
 * @param r ai[z
 * @param dcount ʊpf[^
 * @return z֐
 */
  public DistributionFunction getDistributionFunction(double r[],
      	      	      	      	      	      	      int dcount){
    DistributionFunction df[]=new DistributionFunction[count];
    for(int i=0;i<count;i++){
      df[i]=orbit[i].getDistributionFunction(r,dcount);
    }
    return new MultiDistributionFunction(count,df);
  }

//--------------------------------------------------------------------//
/**
 * z֐Ԃ
 * @param x <i>x</i> i[z
 * @param dcount ʊpf[^
 * @return z֐
 */
  public DistributionFunction getDistributionFunctionX(double x[],
      	      	      	      	      	      	       int dcount){
    DistributionFunction df[]=new DistributionFunction[count];
    for(int i=0;i<count;i++){
      df[i]=orbit[i].getDistributionFunctionX(x,dcount);
    }
    return new MultiDistributionFunction(count,df);
  }
}
