package math;
import java.awt.geom.Point2D;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * 3XvCԃNX
 */
public class CubicSplineIP
  extends SequenceFunction implements DifferentiableFunction{

/**
 * ԃIuWFNg\z
 * @param n _̐
 * @param x _ <i>x</i> Wi[z
 * @param y _ <i>y</i> Wi[z
 */
  public CubicSplineIP(int n,double x[],double y[]){
    super();
    this.x=new double[n];
    System.arraycopy(x,0,this.x,0,n);
    functions=getCoefficient(n-1,x,y);
  }

/**
 * ԃIuWFNg\z
 * @param n _̐
 * @param p _i[z
 */
  public CubicSplineIP(int n,Point2D p[]){
    super();
    x=new double[n];
    double y[]=new double[n];
    for(int i=0;i<n;i++){
      x[i]=p[i].getX();
      y[i]=p[i].getY();
    }
    functions=getCoefficient(n-1,x,y);
  }

//--------------------------------------------------------------------//
/**
 * Wݒ肷
 * @param n _̐
 * @param x _ <i>x</i> Wi[z
 * @param y _ <i>y</i> Wi[z
 * @return Ԋ֐̌Wi[z
 */
  protected Function[] getCoefficient(int n,double x[],double y[]){
    if(n<=0){
      Function coef[]={new ConstantFunction(y[0])};
      return coef;
    }
    else{
      Function coef[]=new Function[n];
      double h[]=new double[n];
      double hinv[]=new double[n];
      double gamma[]=new double[n];
      double xm[]=new double[n];

      h[0]=x[1]-x[0];
      hinv[0]=1.0/h[0];
      h[1]=x[2]-x[1];
      hinv[1]=1.0/h[1];
      double bb=h[1]*h[0]+1.0;
      double balpha=0.5/bb;
      double e1=(y[1]-y[0])*hinv[0];
      double e2=(y[2]-y[1])*hinv[1];
      xm[0]=(e2-e1)*hinv[0]*balpha;
      for(int i=2;i<n;i++){
      	h[i]=x[i+1]-x[i];
      	hinv[i]=1.0/h[i];
      	gamma[i-1]=(bb-1.0)*balpha;
      	bb=h[i]*hinv[i-1]+1.0;
      	balpha=1.0/(bb+bb-gamma[i-1]);
      	e1=e2;
      	e2=(y[i+1]-y[i])*hinv[i];
      	xm[i-1]=((e2-e1)*hinv[i-1]-xm[i-2])*balpha;
      }
      xm[n-1]=0.0;
      for(int i=n-3;i>=0;i--) xm[i]=xm[i]-gamma[i]*xm[i+1];
      double a30=xm[0];
      double a20=xm[0]*x[0];
      double a10=a20*x[0];
      double a3=a30*hinv[0];
      double a2=-3.0*a20*hinv[0];
      double a1=(3.0*a10+y[1]-y[0])*hinv[0]-a30*h[0];
      double a0=(y[0]*x[1]-(a10+y[1])*x[0])*hinv[0]+a20*h[0];
      coef[0]=new CubicFunction(a3,a2,a1,a0);
      for(int i=1;i<n;i++){
      	a30=xm[i]-xm[i-1];
      	double a21=xm[i-1]*x[i+1];
      	double a22=xm[i]*x[i];
      	double a11=a21*x[i+1];
      	double a12=a22*x[i];
      	double a00=(a11+y[i])*x[i+1]-(a12+y[i+1])*x[i];
      	a3=a30*hinv[i];
      	a2=3.0*(a21-a22)*hinv[i];
      	a1=(3.0*(a12-a11)+y[i+1]-y[i])*hinv[i]-a30*h[i];
      	a0=a00*hinv[i]-(a21-a22)*h[i];
      	coef[i]=new CubicFunction(a3,a2,a1,a0);
      }
      return coef;
    }
  }

//--------------------------------------------------------------------//
/**
 * ֐Ԃ
 * @return ֐
 */
  public Function getDerivative(){
    double x2[]=new double[x.length];
    System.arraycopy(x,0,x2,0,x.length);
    Function f[]=new Function[functions.length];
    for(int i=0;i<functions.length;i++){
      f[i]=((DifferentiableFunction)functions[i]).getDerivative();
    }
    return new SequenceFunction(x2,f);
  }
}
